REM SET $8C00 AS TOP OF BASIC RAM. THIS IS WHERE ZSMKIT LIB WILL GO
REM FETCH BANK COUNT IN ".A" REGISTER

15 X=RND(-TI)
20 SCREEN 1:COLOR 1,0
25 CLS:PRINT "LOADING ZSMKIT...."
40 POKE $30F,1: SYS $FF99
45 POKE $30D,$00:POKE $30E,$8C:POKE $30F,0:SYS $FF99
REM CLEAR VARIABLES, WHICH RE-READS MEMTOP
50 CLR
REM VV HOLDS CURRENT VOLUME LEVEL, RESERVED !!
60 VV=0
REM NUMBER OF IMAGE FILES AVAILABLE
62 NI=300
63 DEF FN INC(X) = X+1
REM LOAD ZSMKIT LIB
65 BLOAD"ZSMKIT8C00.BIN",8,1,$8C00

REM INITIALIZE ZSMKIT
70 GOSUB 2000

75 REM SET THIN FONT
76 POKE$30C,4:SYS$FF62

80 CLS:PRINT

100 PRINT "SET UP SLIDE SHOW VARIABLES":PRINT
110 COLOR 5:PRINT "     1.";:COLOR 1:PRINT "   RANDOM IMAGES"
120 COLOR 5:PRINT "     2.";:COLOR 1:PRINT "   SEQUENTIAL IMAGES THEN LOOP"
130 COLOR 5:PRINT "     3.";:COLOR 1:PRINT "   SEQUENTIAL IMAGES THEN END"
135 COLOR 5:PRINT "     4.";:COLOR 1:PRINT "   END NOW AND ABORT"

140 PRINT:PRINT:COLOR 1
145 PRINT:INPUT "CHOICE: ";C
150 IF C=1 OR C=2 OR C=3 THEN 170
160 IF C=4 THEN RESET
165 PRINT CHR$(7):GOTO 80
170 PRINT:PRINT:PRINT
180 INPUT "PLAY MUSIC  Y/N";MU$
190 IF LEN(MU$)>1 THEN MU$=LEFT$(MU$,1)
200 IF MU$="Y" OR MU$="N" THEN 220
210 PRINT "INVALID CHOICE !";CHR$(7):GOTO 145
220 IF MU$="Y" THEN 250
230 GOTO 405


250 CLS:PRINT:PRINT
255 PRINT "CHOOSE SOUNDTRACK":PRINT
260 PRINT "    1. CANYON.ZSM"
265 PRINT "    2. SB_INTRO.ZSM"
266 PRINT "    3. GUILE.ZSM":
267 PRINT:PRINT
270 COLOR 7
275 PRINT "CANYON.ZSM & GUILE.ZSM":COLOR 5:PRINT
276 PRINT " ARE FROM THE CX16-DEV SD, AUDIO DEMOS"
280 PRINT " I DON'T KNOW WHERE TO GIVE CREDIT FOR CANYON OR GUILE"
285 PRINT:PRINT:COLOR 7
290 PRINT "SB_INTRO.ZSM":COLOR 5:PRINT:PRINT "                PROVIDED BY: ";
295 COLOR 7
296 PRINT "NICCO1690":COLOR 5
300 PRINT " ORIGINAL MUSIC COMPOSED BY: ";:COLOR 7
310 PRINT "TERO & TONI HILIPNEN":PRINT:PRINT
315 COLOR 1
320 INPUT "SOUNDTRACK CHOICE: ";MC
330 IF MC<> 1 AND MC<> 2 AND MC<> 3 THEN 402

340 IF MC=1 THEN MF$="CANYON.ZSM"
350 IF MC=2 THEN MF$="SB_INTRO.ZSM"
355 IF MC=3 THEN MF$="GUILE.ZSM"
360 COLOR 1:LOCATE 2,2:CLS:PRINT "LOADING ";MF$
370 GOSUB 2100:GOSUB 2200
390 I1 = 0
395 D0=0
400 DT=0:GOTO 405

402 PRINT "INVALID CHOICE";CHR$(7):SLEEP 90:GOTO 250


405 PRINT:PRINT
410 INPUT "FAST MODE (MINIMAL DELAY) Y/N";X$
415 IF X$<>"" THEN X$=LEFT$(X$,1)
420 IF X$="Y" OR X$="N" THEN 430
425 PRINT CHR$(7):GOTO 410

430 PRINT:PRINT:COLOR 5
431 PRINT "WILL NOT BE VISIBLE ON ALL IMAGES":COLOR 1
432 INPUT "SHOW IMAGE FILE NAME   Y/N";FS$
435 IF FS$<>"" THEN FS$=LEFT$(FS$,1)
438 IF FS$="Y" OR FS$="N" THEN 443
440 PRINT CHR$(7):GOTO 430



REM ID IS IMAGE DELAY
443 ID=1750:IF X$="Y" THEN ID=350
444 SCREEN $80:SLEEP 0:RECT 0,0,319,239,$10
445 REM REPEAT
REM SELECT IMG NUMBER
450 IF C=1 THEN I1=INT(RND(1)*NI)+1
451 IF C=1 THEN 460
452 I1= FNINC(I1):DT=0
453 IF I1=NI+1 AND C=3 THEN D0=1:GOTO 540
454 IF I1=NI+1 THEN I1=0:GOTO 452
460 SF$=RIGHT$(STR$(I1),LEN(STR$(I1))-1)
470 IF LEN(SF$)<3 THEN SF$= RPT$(ASC("0"),3-LEN(SF$))+SF$
475 SF$=SF$+".BIN"
480 IM$="DATA/"+"IMG"+SF$
485 PA$="DATA/"+"VPAL"+SF$
500 GOSUB 44500:REM BLACK OUT THE PALLETTE
505 GOSUB 1000
510 BVLOAD IM$,8,0,0
520 BVLOAD PA$,8,1,$FA00
522 IF FS$="N" THEN 530
523 COLOR 1,0
524 LOCATE 2,2:PRINT "                                        ";
525 LOCATE 2,2:PRINT IM$;
530 GOSUB 1000
535 IF DT < ID THEN 530
540 DT=0
REM UNTIL D0<>0
545 IF D0=0 THEN 450


570 RESET





1000 GET Z$
1005 Z=ASC(Z$)
1010 IF Z=32 THEN GOSUB 1400:RETURN
1020 IF Z=17 THEN GOSUB 2600
1030 IF Z=145 THEN GOSUB 2700
1030 DT=DT+1
1040 IF Z=27 THEN GOSUB 1100
1050 RETURN

1100 P1=1
1105 GOSUB 40100
1110 R1%=R%:G1%=G%:B1%=B%
1115 R%=15:G%=15:B%=15 : GOSUB 40000
1120 P1=8
1125 GOSUB 40100
1130 R2%=R%:G2%=G%:B2%=B%
1135 R%=2:G%=2:B%=2 : GOSUB 40000
1140 X=7:Y=10:COLOR 1,8
1145 H=9:W=30
1150 GOSUB 3600
1160 LOCATE 12,9
1170 PRINT "DO YOU REALLY WANT TO QUIT?";
1175 LOCATE 14,9:PRINT " HIT <ESC> AGAIN TO RESET";
1176 LOCATE 16 ,9:PRINT " ANY OTHER KEY TO CONTINUE";
1180 GET X$:IF X$="" THEN 1180
1190 IF X$=CHR$(27) THEN RESET
1200 R%=R1%:G%=G1%:B%=B1%:P1=1
1205 GOSUB 40000
1210 R%=R2%:G%=G2%:B%=B2%:P1=8
1220 GOSUB 40000
1225 COLOR 1,0:CLS
1230 RETURN








REM FLIP PLAYSTATE
1400 IF PS=1 THEN GOSUB 2400:RETURN
1410 GOSUB 2200:RETURN

1500 IF C=1 THEN I1=INT(RND(1)*NI)+1:RETURN
1500 IF C=2 OR C=3 THEN I1=I1+1
1510 IF C=3 AND C1=NI THEN:DONE=1:RETURN
1520 IF I1>NI THEN I1=1
1525 RETURN

REM INITIALIZE ZSMKIT
REM RAM BANK 1 IS GIVEN TO ZSMKIT
REM ZSM-INIT-ENGINE
2000 POKE $30C,1
2010 SYS $8C00
REM SET UP THE DEFAULT INTERRUPT HANDLER
REM ZSMKIT-SETISR
2020 SYS $8C54
REM NOW ZSMKIT IS ALL SET UP TO PLAY MUSIC
2030 RETURN

REM LOAD THE DEFAULT SONG. ZSMKIT OWNS BANK 1, SO LOAD SONG
REM STARTING IN BANK 2
2100 BLOAD MF$,8,2,$A000
REM NOW TELL ZSMKIT WHERE THE SONG LIVES
REM USE ZSMKIT PRIORITY (SLOT) 0
2110 BANK 2:POKE$30D,0:POKE$30C,$00:POKE$30E,$A0
REM ZSM-SETMEM
2120 SYS $8C1E
REM NOW WE'RE CLEAR TO START SONG PLAYBACK
2130 RETURN

REM START PLAYBACK
REM PRIORITY (SLOT) 0, THEN ZSM-PLAY
2200 POKE$30D, 0
2201 PS=1
2210 SYS $8C06
2215 RETURN

REM PAUSE PLAYBACK
REM PRIORITY (SLOT) 0, THEN ZSM-STOP
2400 POKE$30D,0
2410 SYS $8C09
2411 PS=0
2415 RETURN

REM VOLUME DOWN
2600 IF  VV>=63 THEN RETURN
2605 VV=VV+1
2610 POKE $30D, 0
2620 POKE $30C, VV
REM ZSM_SETATTEN
2625 SYS $8C21
2630 RETURN

REM VOLUME UP
2700 VV=VV-1
2705 IF VV<=0 THEN VV=0:RETURN
2710 POKE $30D, 0
2720 POKE $30C, 0
REM ZSM_SETATTEN
2730 SYS $8C21
2740 RETURN



REM DRAW TEXT BOX WITH BORDER.  COPIED FROM HANGMAN
3600 LOCATE Y,X
3605 PRINT CHR$($6F);RPT$($A3,W-2);CHR$($70);
3610 IF H=2 THEN 3635
3615 FOR II = 1 TO H-2
3620     LOCATE Y+II,X
3625     PRINT CHR$($A5);RPT$(32,W-2);CHR$($A7);
3630 NEXT II
3635 LOCATE Y+H-1,X
3640 PRINT CHR$($6C);RPT$($A4,W-2);CHR$($BA);
3645 RETURN














REM SET OF GOSUBS FOR DIRECT VERA PALLETTE MANIPULATION
REM USES VPOKE & VPEEK
REM FOR THE OTHER ROUTINES TO WORK RELIABLY SHOULD GOSUB 45000
REM FIRST.    ALSO GOSUB 45000 IS USED AT ANY TIME TO RESET
REM THE VERA PALLETTE TO DEFAULT VALUES.
REM ..
REM ...
REM WHEN THE VERA IS INITIALLY SET TO GRAPHICS MODE IT USES THE
REM DEFAULT PALLETTE BUT IF YOU USE VPEEK TO READ IT RETURNS
REM RANDOM GARBAGE...    AFTER YOU VPOKE THEM IT ALL WORKS
REM AS EXPECTED.
REM .
REM ..
REM ...
REM THIS CODE DOES ABSOLUTELY NO ERROR CHECKING !!!!!!
REM IF USING R%,G% OR B% VALUES SHOULD ALWAYS BE BETWEEN
REM 0-15
REM .
REM ..
REM ...
REM WHEN USING P1 AND P2 TO POINT AT PALLETTE ENTRYS THEY SHOULD
REM ALWAYS BE BETWEEN 0 AND 255
REM I HAD ERROR CHECKING CODE WHEN WRITING THESE ROUTINES
REM BUT ERROR CHECKING TAKES CPU CYCLES....   JUST KEEP THE VALUES
REM CORRECT BEFORE CALLING.
REM .
REM ..
REM ...
REM ..
REM GOSUB 45000..   POKES IN THE DEFAULT PALLETTE VALUES
REM                 SHOULD BE CALLED AT INIT.   AND THEN ANY TIME
REM                 TO RESET THE VERA TO DEFAULT VALUES
REM ..
REM GOSUB 40000..   SETS PALLETTE ENTRY P1 TO R%,G%,B%
REM ..
REM GOSUB 40100..   READS VALUES AT P1 RETURNS IN R%,G%,B%
REM ..
REM GOSUB 40200..   CHANGES THE PALLETTE COLOR P2 TO P1. BUT DIFFERENT THAN 41000
REM                 41000 CHANGES IT FAST.   40200 IMPLEMENTS A FADE WITH SPEED
REM                 CONTROLLED BY THE VALUE OF J (BIGGER VALUE=SLOWER)
REM                 ACTUALLY MOST OF THE WORK DONE BY GOSUB TO 40300
REM ..
REM GOSUB 40300     FADES PALLETTE COLOR AT P1 TO R%,G%,B%
REM                 SPEED CONTROLLED BY THE VALUE OF J.    1 TO 10
REM                 IS SO FAR BEST FOR ME BUT I DIDN'T RESTRICT VALUES
REM                 THE BIGGER J IS.. THE SLOWER THE FADE.
REM ..
REM GOSUB 40500..   SWAPS THE PALLETTE VALUES BETWEEN P1 AND P2
REM                 IF AND ITS A BIG IF...  I MAKE FURTHER CHANGES
REM                 THE NEXT ROUTINE I MAKE WILL BE TO DO THIS AS A
REM                 ..FADE.. USING A SIMILIAR ALGORITHM I USED IN GOSUB 40300
REM ..
REM GOSUB 41000..   COPYS PALLETTE ENTRY P1 TO P2.   P1 IS UNCHANGED
REM ..
REM .
REM GOSUB 44500..   SETS THE PALLETTE TO ALL BLACK.  CAN DRAW STUFF ON SCREEN
REM                 OR LOAD AN IMAGE UNSEEN.   THEN LOAD A PALLETTE TO REVEAL IT.
REM ..
REM ...



39995 REM SET PALLETTE ENTRY P1 TO R%,G%,B%
40000 VPOKE 1,$FA00+(P1*2),(G%*16) + B%
40010 VPOKE 1,$FA00+((P1*2)+1),R%
40020 RETURN

40100 REM READ PALLETTE ENTRY AT P1
40100 REM RETURNED IN %R,%G,%B
40100 A1 = $FA00+(P1*2)
40105 R% = VPEEK(1,A1+1)
40110 GB%= VPEEK(1,A1)
40115 G% = GB%/16
40120 B% = GB% AND $0F
40125 RETURN

40199 FADE P2 FROM CURRENT COLOR TO P1 COLOR, J IS JIFFY DELAY
40200 GOSUB 40100
40205 P3=P1
40210 P1=P2
40215 GOSUB 40300
40220 P1=P3
40225 RETURN


40299 REM FADE P1 TO R%,G%,B%, J IS JIFFY DELAY
40300 DR%=R%:DG%=G%:DB%=B%
40305 GOSUB 40100
40310 RI=1:IF DR%<R% THEN RI=-1
40315 GI=1:IF DG%<G% THEN GI=-1
40320 BI=1:IF DB%<B% THEN BI=-1
40325 IF DR%<>R% THEN R%=R%+RI
40330 IF DG%<>G% THEN G%=G%+GI
40335 IF DB%<>B% THEN B%=B%+BI
40340 GOSUB 40000
40345 SLEEP J
40350 IF DR%=R% AND DG%=G% AND DB%=B% THEN 40360
40355 GOTO 40325
40360 RETURN


40499 REM SWAP PALLETTE COLORS AT P1 & P2
40500 A1 = $FA00+(P1*2)
40505 A2 = $FA00+(P2*2)
40510 B1 = VPEEK (1,A1)
40515 B2 = VPEEK (1,A1+1)
40520 B3 = VPEEK (1,A2)
40525 B4 = VPEEK (1,A2+1)
40530 VPOKE 1, A1, B3
40535 VPOKE 1, A1+1, B4
40540 VPOKE 1, A2, B1
40550 VPOKE 1, A2+1, B2
40560 RETURN

REM COPY P1 PALLETTE ENTRY TO P2.. P1 IS LEFT UNCHANGED.
41000 VPOKE 1,$FA00+(P2*2), VPEEK(1, $FA00+(P1*2))
41010 VPOKE 1,$FA00+(P2*2)+1, VPEEK(1, $FA00+(P1*2)+1)
41020 RETURN

REM SET THE PALLETTE TO ALL BLACK
44500 SLEEP 0
44505 FOR A=$FA00 TO $FBFF
44510     VPOKE 1,A,0
44520 NEXT A
44530 RETURN


45000 RESTORE 50000
45010 REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
45015 REM AND POKE THE VERA DEFAULT PALLETTE
45020 FOR PE = $FA00 TO $FBFE STEP 2
45025     READ R:READ GB
45030     VPOKE 1,PE,GB
45035     VPOKE 1,PE+1, R
45040 NEXT PE
45050 RETURN

49999 REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
50000 DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
50005 DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
50010 DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
50015 DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
50020 DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
50025 DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
50030 DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
50035 DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
50040 DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
50045 DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
50050 DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
50055 DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
50060 DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
50065 DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
50070 DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
50075 DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
50080 DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
50085 DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
50090 DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
50095 DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
50100 DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
50105 DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
50110 DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
50115 DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
50120 DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
50125 DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
50130 DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
50135 DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
50140 DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
50145 DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
50150 DATA $0F,$0B








