REM SET $8C00 AS TOP OF BASIC RAM. THIS IS WHERE ZSMKIT LIB WILL GO
REM FETCH BANK COUNT IN ".A" REGISTER
5 PRINT FRE(0)
10 POKE $30F,1: SYS $FF99 
20 POKE $30D,$00:POKE $30E,$8C:POKE $30F,0:SYS $FF99

REM CLEAR VARIABLES, WHICH RE-READS MEMTOP
30 CLR 
31 PRINT FRE(0)
REM NAME OF ZSM TO LOAD
35 MF$="CANYON.ZSM"
REM ZV HOLDS CURRENT VOLUME LEVEL, RESERVED !!
36 ZV=0 

REM LOAD ZSMKIT LIB
40 BLOAD"ZSMKIT8C00.BIN",8,1,$8C00 

REM INITIALIZE ZSMKIT
REM RAM BANK 1 IS GIVEN TO ZSMKIT
REM ZSM-INIT-ENGINE
50 POKE $30C,1 
60 SYS $8C00 

REM SET UP THE DEFAULT INTERRUPT HANDLER
REM ZSMKIT-SETISR
70 SYS $8C54 
REM NOW ZSMKIT IS ALL SET UP TO PLAY MUSIC

REM LOAD THE DEFAULT SONG. ZSMKIT OWNS BANK 1, SO LOAD SONG
REM STARTING IN BANK 2
130 BLOAD MF$,8,2,$A000 

REM NOW TELL ZSMKIT WHERE THE SONG LIVES
REM USE ZSMKIT PRIORITY (SLOT) 0
160 BANK 2:POKE$30D,0:POKE$30C,$00:POKE$30E,$A0
REM ZSM-SETMEM
170 SYS $8C1E 
REM NOW WE'RE CLEAR TO START SONG PLAYBACK

REM PLAY THE SONG
REM PRIORITY (SLOT) 0, THEN ZSM-PLAY
190 POKE$30D,0 
200 SYS $8C06 
210 PRINT "TO STOP SONG TYPE: RUN 500"
220 PRINT "SONG DRIVER WILL STAY RESIDENT"
225 PRINT "RUN 600 --> VOLUME DOWN"
226 PRINT "RUN 700 --> VOLUME UP"
230 END


REM PRIORITY (SLOT) 0, THEN ZSM-STOP
500 POKE$30D,0 
510 SYS $8C09 
520 PRINT "TO CONTINUE SONG TYPE: RUN 190"
525 PRINT "RUN 600 --> VOLUME DOWN"
526 PRINT "RUN 700 --> VOLUME UP"
530 END

REM VOLUME DOWN 
600 IF  ZV>=63 THEN END
605 ZV=ZV+1
610 POKE $30D, 0
620 POKE $30C, ZV
REM ZSM_SETATTEN
625 SYS $8C21 
630 END


REM VOLUME UP
700 IF ZV<=0 THEN END
705 ZV=ZV-1
710 POKE $30D, 0
720 POKE $30C, ZV
REM ZSM_SETATTEN
730 SYS $8C21 
740 END

